/*
 *  sale.h
 *  
 *  Author: G. Ianni
 *  Si ringrazia Gennaro Frazzingaro per la trascrizione.
 *
 */

#include <JTC/jtc.h>
#include <time.h>

#define N 2

class Sala : JTCMonitor
{
	bool pista[N];
	int palleDisponibili;
	int cercaPista()
	{
		for(int i = 0; i<N; i++)
		{
			if(!pista[i])
				return i;
			return -1;
		}
	}
public:
	int richiediPista(int numGiocatori) //con starvation
	{
		JTCSynchronized sync(*this);
		int p;
		while((p=cercaPista())==-1 || palleDisponibili < numGiocatori)
			wait();
		pista[p] = true;
		palleDisponibili -= numGiocatori;
		return p;
	}

	void liberaPista(int numPista, int numGiocatori)
	{
		JTCSynchronized sync(*this);
		palleDisponibili += numGiocatori;
		pista[numPista] = false;
		notifyAll();
	}
};

Sala* s;

class Giocatore : public JTCThread
{	
public:
	virtual void run()
	{
		srand(time(0));
		while(true)
		{
			int numPalleVolute = rand() % 20;
			sleep(1000);
			int pista = s->richiediPista(numPalleVolute);
			sleep(1000);
			s->liberaPista(pista,numPalleVolute);
		}
	}
};

void main()
{
	JTCInitialize init;
	s = new Sala();
	//...
}
