/*
 *  
 *  Author: G. Ianni
 *
 *  Sala Bowling senza starvation
 */

#include <JTC/JTC.h>
#include <time.h>

#define N 2

class SalaNoStarvation : public JTCMonitor 
{
	bool pista[N];
	int palleDisponibili;
	int prossimoDaServire;
	int prossimoBollino;
public:
	int cercaPista()
	{
		for(int i = 0; i<N; i++)
		{
			if(!pista[i])
				return i;
			return -1;
		}
	}

	bool cePistaLibera()
	{
		return cercaPista() != -1;
	}

	int richiediPista(int numGiocatori)
	{
		int mioTurno;
		JTCSynchronized sync(*this);
	    mioTurno = prossimoBollino++;
	    while( !cePistaLibera() || numGiocatori > palleDisponibili ||
	           mioTurno != prossimoDaServire )
	    {
	    	wait();
	    }
	    prossimoDaServire++; 
		// possibilit immediata di provare a giocare per il prossimo numero da servire. 
		notifyAll();
	    palleDisponibili -= numGiocatori;
	    int i = cercaPista();
	    pista[i] = true;
	    return cercaPista();
	}

	void liberaPista(int codicePista, int numGiocatori)
	{
		JTCSynchronized sync(*this);
		pista[codicePista] = false;
		palleDisponibili += numGiocatori;
		notifyAll();
	}
};

SalaNoStarvation* s;

class Giocatore : public JTCThread
{	
public:
	virtual void run()
	{
		srand(time(0));
		while(true)
		{
			int numPalleVolute = rand() % 20;
			sleep(1000);
			int pista = s->richiediPista(numPalleVolute);
			sleep(1000);
			s->liberaPista(pista,numPalleVolute);
		}
	}
};

int main()
{
	JTCInitialize init;
	s = new SalaNoStarvation();
	//...
	
	return 0;
}

